//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// VOLUME MANAGEMENT FUNCTIONS EXAMPLE

#include <hpgcc3.h>

int main()
{
int error;
int f;


clear_screen();

// SHOW INFORMATION ABOUT MOUNTED VOLUMES
for(f=0;f<4;++f)
{
error=FSVolumeInserted(f);
if(error==FS_OK)
 {
printf("Volume %d (:%d: %c:) mounted.\n",f,f+3,(char) (f+'C'));
printf("Size: %d Kb, %d kB free.\n",FSGetVolumeSize(f)/1024,FSGetVolumeFree(f)/1024);
}
else {
// IF error==FS_BADVOLUME, THEN THERE IS NO VOLUME f IN THE CURRENTLY INSERTED CARD
if(error!=FS_BADVOLUME) printf("Error=%s\n",FSGetErrorMsg(error));
}
}

// SET/GET CURRENT VOLUME

for(f=0;f<4;++f)
{
error=FSSetCurrentVolume(f);
if(error==FS_OK) printf("Curr. vol. changed to :%d:\n",f+3);
else {
printf("Error: %s\n",FSGetErrorMsg(error));
}
printf("Current volume is :%d:\n",FSGetCurrentVolume(f)+3);

}

getchar();

// CARD DETECTION TEST

printf("Card detection test, press ON to exit\n");
printf("Take the card out\n");

do {
error=FSVolumeInserted(FSGetCurrentVolume());
if(keyb_isON()) break;
} while(error==FS_OK);

if(error==FS_NOCARD) {
printf("Insert the same card back or a different card\n");

do {
error=FSVolumeInserted(FSGetCurrentVolume());
if(keyb_isON()) break;
} while(error==FS_NOCARD);

printf(FSGetErrorMsg(error));
printf("\n");
if(error==FS_OK) printf("Same card is back in\n");
if(error==FS_CHANGED) {
printf("Card was changed, insert the original card back\n");
do {
error=FSVolumeInserted(FSGetCurrentVolume());
if(keyb_isON()) break;
} while(error!=FS_OK);

if(error==FS_OK) printf("Same card is back in\n");
}

}

// NOT REALLY NEEDED, SHUTDOWN IS CALLED AUTOMATICALLY
// BUT IT'S ALWAYS A GOOD IDEA TO CALL IT MANUALLY AND CHECK
// FOR ERRORS
error=FSShutdown();
if(error==FS_OK) printf("Shutdown OK\n");
else printf("Shutdown error: %s", FSGetErrorMsg(error));


printf("Exit\n");
getchar();

return 0;
}




