//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// DIRECTORY MANAGEMENT FUNCTIONS EXAMPLE

#include <hpgcc3.h>

void printdir()
{
FS_FILE *dir;
FS_FILE entry;
int f,files,totalsize;

f=FSOpenDir(".",&dir);

if(f!=FS_OK) {
printf("OpenDir error: %s\n",FSGetErrorMsg(f));
return;
}

printf("Dir:: %s\n",FSGetFileName(dir,FSNAME_HASVOL | FSNAME_VOLHP | FSNAME_HASPATH | FSNAME_ABSPATH | FSNAME_ENDSLASH));

files=0;
totalsize=0;
while(FSGetNextEntry(&entry,dir)==FS_OK) {
printf("%s | %d b\n",entry.Name,entry.FileSize);

totalsize+=entry.FileSize;
FSReleaseEntry(&entry);
++files;
}
printf("%d files, %d bytes\n",files,totalsize);
f=FSClose(dir);
if(f!=FS_OK) printf("FClose error: %s\n",FSGetErrorMsg(f));

}




int main()
{
int error;
int f;

clear_screen();

// SHOW INFORMATION ABOUT MOUNTED VOLUMES
for(f=0;f<4;++f)
{
error=FSVolumeInserted(f);
if(error==FS_OK)
 {
printf("Volume %d (:%d: %c:) mounted.\n",f,f+3,f+'C');
printf("Size: %d Kb, %d kB free.\n",FSGetVolumeSize(f)/1024,FSGetVolumeFree(f)/1024);
}
else {
// IF error==FS_BADVOLUME, THEN THERE IS NO VOLUME f IN THE CURRENTLY INSERTED CARD
if(error!=FS_BADVOLUME) printf("Error=%s\n",FSGetErrorMsg(error));
}
}

// SET/GET CURRENT VOLUME

for(f=0;f<4;++f)
{
error=FSSetCurrentVolume(f);
if(error==FS_OK) {
printf("Curr. vol. changed to :%d:\n",f+3);
printdir();
getchar();
}

}


// NOT REALLY NEEDED, SHUTDOWN IS CALLED AUTOMATICALLY
// BUT IT'S ALWAYS A GOOD IDEA TO CALL IT MANUALLY AND CHECK
// FOR ERRORS
error=FSShutdown();
if(error==FS_OK) printf("Shutdown OK\n");
else printf("Shutdown error: %s", FSGetErrorMsg(error));


printf("Exit\n");
getchar();

return 0;
}



