#include <hpgcc3.h>

#include "memblock.h"
#include "gstring.h"
#include "gui.h"

gEditBox *ebox;
gCheckBox *leave;

gForm *msgbox;
gSoftMenu *msgmenu;

BOOL TerminateEvent(gEvent *e,gControl *This)
{
	if(leave->GetState()) {
	int n;
	n=ebox->Strlen();
	char *data=new char[n+1];
	if(data) {
		n=ebox->GetText(data,n);
		data[n]=0;
		SAT_OBJECT string=sat3_createcstr_str(ALLOC_TEMPOB,data);
		if(string) sat3_push(string);
		delete data;
	}
	}
	This->GetApplication()->Terminate(0);
	return TRUE;
}
BOOL CancelBoxEvent(gEvent *e,gControl *This)
{
	// DO CUSTOM CANCEL ACTIONS HERE
	
// SEND CLOSE EVENT TO THE FORM
	This->GetApplication()->CloseForm(This->Parent);
return TRUE;
}

BOOL OKBoxEvent(gEvent *e,gControl *This)
{
	// DO CUSTOM OK ACTIONS HERE
	
// SEND CLOSE EVENT TO THE FORM
This->GetApplication()->CloseForm(This->Parent);
return TRUE;
}

BOOL DummyBoxEvent(gEvent *e,gControl *This)
{
return TRUE;
}

BOOL MessageBoxEvent(gEvent *e,gControl *This)
{
gApplication *ap=(gApplication *)This->GetApplication();
msgbox=new gForm(*ap,"Really Exit?",(gFormStyles)(S_HASBORDER | S_SHADE | S_TOPCAPTION | S_EXSOFTMENU), 13,20,80,30);
msgmenu=new gSoftMenu(*msgbox,S_EXSOFTMENU);

msgmenu->AddItem("CANCEL",&CancelBoxEvent);
msgmenu->AddItem("",&DummyBoxEvent);
msgmenu->AddItem("",&DummyBoxEvent);
msgmenu->AddItem("",&DummyBoxEvent);
msgmenu->AddItem("",&DummyBoxEvent);
msgmenu->AddItem("OK",&OKBoxEvent);

// OPEN THE FORM AND GIVE IT FOCUS
ap->OpenNewForm(msgbox);

return TRUE;
}



BOOL CoolEvent(gEvent *e,gControl *This)
{
static int count=0;
char data[50];
gApplication *ap=This->GetApplication();

	sprintf(data,"Count:%03d",count);
	++count;
	ap->ClearClipRegion();
	gFont f(5);
	This->GetApplication()->DrawTextBk(70,70,data,&f,GWHITE,GBLACK);
	return FALSE;
}


int main()
	{
		gApplication App;
		gFont ff(6);
		int f;

		// ADD CONTROLS HERE
		gForm mainform(App,"Hello World!",(gFormStyles) (S_TOPCAPTION |S_EXSOFTMENU));
		
		mainform.AddHandler(GEVENT_KEYB,-1,KM_PRESS | SHIFT_LS | SHIFT_LSHOLD | KB_U ,&TerminateEvent);
		mainform.AddHandler(GEVENT_IDLE,0,0,&CoolEvent);
		
		gSoftMenu m(mainform,S_EXSOFTMENU);
		
		
		m.AddItem("EXIT",&TerminateEvent);
		m.AddItem("MSG",&MessageBoxEvent);

		gStaticText myText(mainform,20,10,"Leave message on stack",&ff,GBLACK);
		gCheckBox chk1(mainform,10,10);

		leave=&chk1;

		gStaticText myText2(mainform,20,20,"Type a message: ",&ff,GBLACK);
//		gCheckBox chk2(mainform,40,16,S_DOT);
//		gCheckBox chk3(mainform,40,22,S_PLUS);
//		gCheckBox chk4(mainform,40,28,S_MINUS);
		
		gEditBox myEdit(mainform,10,26,110,-4,(gStyles)(S_HASBORDER | S_VSCROLLBAR | S_MULTILINE),&ff);
		
		myEdit.SetText("Hello World!");
		
		ebox=&myEdit;
		return App.Run();
		

}

